Package com.ads.mm.etl.xml.mapping

# Class MMDBColumn

java.lang.Object
com.ads.mm.etl.xml.mapping.MMUUID
com.ads.mm.etl.xml.mapping.MMDBColumn

All Implemented Interfaces:
  `Cloneable`

public class MMDBColumn extends MMUUID implements Cloneable

Author:
  Syed Abdul Rahim

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `MMDBColumn.AppendedColumn`

- ## Field Summary

  ### Fields inherited from class com.ads.mm.etl.xml.mapping.MMUUID

  `_associatedIDs, _associatedUUIDs, uniqueName`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MMDBColumn(MMMappingUtil mappingUtil, String colName)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addTransformation(MMMapping mapping, MMMappingTransformation mmmTrans)`
  `protected Object`
  `clone()`
  `static MMDBColumn`
  `findFirstValidColumn(ArrayList<MMDBColumn> mmdbcList)`
  `String`
  `getColumnAlias()`
  `String`
  `getColumnClass()`
  `String`
  `getColumnComments()`
  `String`
  `getColumnName()`
  `int`
  `getCopyColumnCount(String mappingId)`
  `int`
  `getCopyDerviedColumnCount(String mappingId)`
  `String`
  `getDataType()`
  `String`
  `getDefaultValue()`
  `String`
  `getDefinitionComments()`
  `String`
  `getForeignKeyColumn()`
  `String`
  `getForeignKeyTable()`
  `String`
  `getId()`
  `String`
  `getIdentityFlag()`
  `String`
  `getLength()`
  `String`
  `getLogicalColumnName()`
  `MMMappingUtil`
  `getMappingUtil()`
  `String`
  `getMaxValue()`
  `String`
  `getMinValue()`
  `String`
  `getNaturalKeyFlag()`
  `String`
  `getNullableFlag()`
  `MMDBTable`
  `getParentTable()`
  `String`
  `getPercenNullValue()`
  `String`
  `getPrecision()`
  `static int`
  `getPreserveCount()`
  `int`
  `getPreservedId(int preserveCount)`
  `String`
  `getScale()`
  `String`
  `getSDIDescription()`
  `MMMappingTransformation`
  `getTransformation(String mappingId)`
  TODO: Remove this method
  `int`
  `getTransformationIndex(String mappingId, MMMappingTransformation mmmTrans)`
  `MMMappingTransformationMap`
  `getTransformations(String mappingId)`
  `HashMap<String,MMMappingTransformationMap>`
  `getTransformationsMap()`
  `String`
  `getXPath()`
  `boolean`
  `isBusinessKeyFlag()`
  `boolean`
  `isCopyColumnRequired()`
  `boolean`
  `isforeignKey()`
  `boolean`
  `isNullableFlag()`
  `boolean`
  `isOrphanFlag()`
  `boolean`
  `isPrimaryKey()`
  `boolean`
  `isSDIFlag()`
  `void`
  `setBusinessKeyFlag(boolean businessKeyFlag)`
  `void`
  `setColumnAlias(String columnAlias)`
  `void`
  `setColumnClass(String columnClass)`
  `void`
  `setColumnComments(String columnComments)`
  `void`
  `setColumnName(String columnName)`
  `void`
  `setCopyColumnCount(String mappingId, int copyColumnCount)`
  `void`
  `setCopyColumnRequired(boolean copyColumnRequired)`
  `void`
  `setCopyDerviedColumnCount(String mappingId, int copyDerviedColumnCount)`
  `void`
  `setDataType(String dataType)`
  `void`
  `setDefaultValue(String defaultValue)`
  `void`
  `setDefinitionComments(String definitionComments)`
  `void`
  `setForeignKeyColumn(String foreignKeyColumn)`
  `void`
  `setForeignKeyFlag(boolean foreignKeyFlag)`
  `void`
  `setForeignKeyFlag(String foreignKeyFlag)`
  `void`
  `setForeignKeyTable(String foreignKeyTable)`
  `void`
  `setId(String id)`
  `void`
  `setIdentityFlag(String identityFlag)`
  `void`
  `setLength(String length)`
  `void`
  `setLogicalColumnName(String logicalColumnName)`
  `void`
  `setMappingUtil(MMMappingUtil mappingUtil)`
  `void`
  `setMaxValue(String maxValue)`
  `void`
  `setMinValue(String minValue)`
  `void`
  `setNaturalKeyFlag(String naturalKeyFlag)`
  `void`
  `setNullableFlag(String nullableFlag)`
  `void`
  `setOrphanFlag(boolean orphanFlag)`
  `void`
  `setParentTable(MMDBTable parentTable)`
  `void`
  `setPercenNullValue(String percenNullValue)`
  `void`
  `setPrecision(String precision)`
  `static void`
  `setPreserveCount(int aPreserveCount)`
  `void`
  `setPrimaryKeyFlag(boolean primaryKeyFlag)`
  `void`
  `setPrimaryKeyFlag(String primaryKeyFlag)`
  `void`
  `setScale(String scale)`
  `void`
  `setSDIDescription(String sdiDescription)`
  `void`
  `setSDIFlag(boolean sdiFlag)`
  `void`
  `setXPath(String xpath)`
  `String`
  `toString()`
  `void`
  `toString(StringBuilder sbu)`

  ### Methods inherited from class com.ads.mm.etl.xml.mapping.MMUUID

  `addAssociatedCrossID, addAssociatedID, addAssociatedUUID, getAssociatedCrossID, getAssociatedID, getAssociatedUUID, getUniqueName, getUUID, setAssociatedIDCount, setUniqueName, setUUID`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### MMDBColumn

    public MMDBColumn(MMMappingUtil mappingUtil, String colName)

- ## Method Details

  - ### getColumnName

    public String getColumnName()
    Returns:
      the columnName

  - ### setColumnName

    public void setColumnName(String columnName)
    Parameters:
      `columnName` - the columnName to set

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`

  - ### toString

    public void toString(StringBuilder sbu)

  - ### getId

    public String getId()
    Returns:
      the id

  - ### setId

    public void setId(String id)
    Parameters:
      `id` - the id to set

  - ### getDataType

    public String getDataType()
    Returns:
      the dataType

  - ### setDataType

    public void setDataType(String dataType)
    Parameters:
      `dataType` - the dataType to set

  - ### getLength

    public String getLength()
    Returns:
      the length

  - ### setLength

    public void setLength(String length)
    Parameters:
      `length` - the length to set

  - ### getPrecision

    public String getPrecision()
    Returns:
      the precision

  - ### setPrecision

    public void setPrecision(String precision)
    Parameters:
      `precision` - the precision to set

  - ### getScale

    public String getScale()
    Returns:
      the scale

  - ### setScale

    public void setScale(String scale)
    Parameters:
      `scale` - the scale to set

  - ### getDefaultValue

    public String getDefaultValue()
    Returns:
      the defaultValue

  - ### setDefaultValue

    public void setDefaultValue(String defaultValue)
    Parameters:
      `defaultValue` - the defaultValue to set

  - ### getDefinitionComments

    public String getDefinitionComments()
    Returns:
      the definitionComments

  - ### setDefinitionComments

    public void setDefinitionComments(String definitionComments)
    Parameters:
      `definitionComments` - the definitionComments to set

  - ### getIdentityFlag

    public String getIdentityFlag()
    Returns:
      the identityFlag

  - ### setIdentityFlag

    public void setIdentityFlag(String identityFlag)
    Parameters:
      `identityFlag` - the identityFlag to set

  - ### isNullableFlag

    public boolean isNullableFlag()

  - ### getNullableFlag

    public String getNullableFlag()
    Returns:
      the nullableFlag

  - ### setNullableFlag

    public void setNullableFlag(String nullableFlag)
    Parameters:
      `nullableFlag` - the nullableFlag to set

  - ### getPercenNullValue

    public String getPercenNullValue()
    Returns:
      the percenNullValue

  - ### setPercenNullValue

    public void setPercenNullValue(String percenNullValue)
    Parameters:
      `percenNullValue` - the percenNullValue to set

  - ### getNaturalKeyFlag

    public String getNaturalKeyFlag()
    Returns:
      the naturalKeyFlag

  - ### setNaturalKeyFlag

    public void setNaturalKeyFlag(String naturalKeyFlag)
    Parameters:
      `naturalKeyFlag` - the naturalKeyFlag to set

  - ### getMinValue

    public String getMinValue()
    Returns:
      the minValue

  - ### setMinValue

    public void setMinValue(String minValue)
    Parameters:
      `minValue` - the minValue to set

  - ### getMaxValue

    public String getMaxValue()
    Returns:
      the maxValue

  - ### setMaxValue

    public void setMaxValue(String maxValue)
    Parameters:
      `maxValue` - the maxValue to set

  - ### getMappingUtil

    public MMMappingUtil getMappingUtil()
    Returns:
      the _mappingUtil

  - ### setMappingUtil

    public void setMappingUtil(MMMappingUtil mappingUtil)
    Parameters:
      `mappingUtil` - the _mappingUtil to set

  - ### getPreserveCount

    public static int getPreserveCount()
    Returns:
      the preserveCount

  - ### setPreserveCount

    public static void setPreserveCount(int aPreserveCount)
    Parameters:
      `aPreserveCount` - the preserveCount to set

  - ### getPreservedId

    public int getPreservedId(int preserveCount)

  - ### getParentTable

    public MMDBTable getParentTable()
    Returns:
      the parentTable

  - ### setParentTable

    public void setParentTable(MMDBTable parentTable)
    Parameters:
      `parentTable` - the parentTable to set

  - ### clone

    protected Object clone() throws CloneNotSupportedException
    Overrides:
      `clone` in class `Object`
    Throws:
      `CloneNotSupportedException`

  - ### isOrphanFlag

    public boolean isOrphanFlag()
    Returns:
      the orphanFlag

  - ### setOrphanFlag

    public void setOrphanFlag(boolean orphanFlag)
    Parameters:
      `orphanFlag` - the orphanFlag to set

  - ### getTransformationsMap

    public HashMap<String,MMMappingTransformationMap> getTransformationsMap()

  - ### getTransformations

    public MMMappingTransformationMap getTransformations(String mappingId)
    Returns:
      the _transformations

  - ### addTransformation

    public void addTransformation(MMMapping mapping, MMMappingTransformation mmmTrans)

  - ### isCopyColumnRequired

    public boolean isCopyColumnRequired()
    Returns:
      the copyColumnRequired

  - ### setCopyColumnRequired

    public void setCopyColumnRequired(boolean copyColumnRequired)
    Parameters:
      `copyColumnRequired` - the copyColumnRequired to set

  - ### getCopyColumnCount

    public int getCopyColumnCount(String mappingId)
    Returns:
      the _hmCopyColumnCount

  - ### setCopyColumnCount

    public void setCopyColumnCount(String mappingId, int copyColumnCount)
    Parameters:
      `copyColumnCount` - the _hmCopyColumnCount to set

  - ### getTransformation

    public MMMappingTransformation getTransformation(String mappingId)
    TODO: Remove this method
    Parameters:
      `mappingId` -
    Returns:
      MMMappingTransformation

  - ### getCopyDerviedColumnCount

    public int getCopyDerviedColumnCount(String mappingId)
    Returns:
      the _hmCopyDerviedColumnCount

  - ### setCopyDerviedColumnCount

    public void setCopyDerviedColumnCount(String mappingId, int copyDerviedColumnCount)
    Parameters:
      `copyDerviedColumnCount` - the _hmCopyDerviedColumnCount to set

  - ### getTransformationIndex

    public int getTransformationIndex(String mappingId, MMMappingTransformation mmmTrans)

  - ### findFirstValidColumn

    public static MMDBColumn findFirstValidColumn(ArrayList<MMDBColumn> mmdbcList)

  - ### isPrimaryKey

    public boolean isPrimaryKey()
    Returns:
      the primaryKeyFlag

  - ### setPrimaryKeyFlag

    public void setPrimaryKeyFlag(String primaryKeyFlag)
    Parameters:
      `primaryKeyFlag` - the primaryKeyFlag to set

  - ### setPrimaryKeyFlag

    public void setPrimaryKeyFlag(boolean primaryKeyFlag)
    Parameters:
      `primaryKeyFlag` - the primaryKeyFlag to set

  - ### isforeignKey

    public boolean isforeignKey()
    Returns:
      the foreignKeyFlag

  - ### setForeignKeyFlag

    public void setForeignKeyFlag(String foreignKeyFlag)
    Parameters:
      `foreignKeyFlag` - the foreignKeyFlag to set

  - ### setForeignKeyFlag

    public void setForeignKeyFlag(boolean foreignKeyFlag)
    Parameters:
      `foreignKeyFlag` - the foreignKeyFlag to set

  - ### getForeignKeyTable

    public String getForeignKeyTable()
    Returns:
      the foreignKeyTable

  - ### setForeignKeyTable

    public void setForeignKeyTable(String foreignKeyTable)
    Parameters:
      `foreignKeyTable` - the foreignKeyTable to set

  - ### getForeignKeyColumn

    public String getForeignKeyColumn()
    Returns:
      the foreignKeyColumn

  - ### setForeignKeyColumn

    public void setForeignKeyColumn(String foreignKeyColumn)
    Parameters:
      `foreignKeyColumn` - the foreignKeyColumn to set

  - ### getColumnClass

    public String getColumnClass()
    Returns:
      the columnClass

  - ### setColumnClass

    public void setColumnClass(String columnClass)
    Parameters:
      `columnClass` - the columnClass to set

  - ### isBusinessKeyFlag

    public boolean isBusinessKeyFlag()
    Returns:
      the businessKeyFlag

  - ### setBusinessKeyFlag

    public void setBusinessKeyFlag(boolean businessKeyFlag)
    Parameters:
      `businessKeyFlag` - the businessKeyFlag to set

  - ### getLogicalColumnName

    public String getLogicalColumnName()
    Returns:
      the logicalColumnName

  - ### setLogicalColumnName

    public void setLogicalColumnName(String logicalColumnName)
    Parameters:
      `logicalColumnName` - the logicalColumnName to set

  - ### getColumnAlias

    public String getColumnAlias()
    Returns:
      the columnAlias

  - ### setColumnAlias

    public void setColumnAlias(String columnAlias)
    Parameters:
      `columnAlias` - the columnAlias to set

  - ### getColumnComments

    public String getColumnComments()
    Returns:
      the columnComments

  - ### setColumnComments

    public void setColumnComments(String columnComments)
    Parameters:
      `columnComments` - the columnComments to set

  - ### isSDIFlag

    public boolean isSDIFlag()
    Returns:
      the sdiFlag

  - ### setSDIFlag

    public void setSDIFlag(boolean sdiFlag)
    Parameters:
      `sdiFlag` - the sdiFlag to set

  - ### getSDIDescription

    public String getSDIDescription()
    Returns:
      the sdiDescription

  - ### setSDIDescription

    public void setSDIDescription(String sdiDescription)
    Parameters:
      `sdiDescription` - the sdiDescription to set

  - ### getXPath

    public String getXPath()
    Returns:
      the xpath

  - ### setXPath

    public void setXPath(String xpath)
    Parameters:
      `xpath` - the xpath to set